# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
defaultencoding = 'utf-8'
#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)
from __init__ import checkInfo,configdict


def get_args():
    env,app = sys.argv[2], sys.argv[8]
    return env,app

cfinfo ={
        'Ubuntu':['Ubuntu 16.04','Ubuntu 18.04'],
        'Red Hat':['Red Hat Enterprise Linux Server release 7.4'],
        'centos': ['CentOS 7.3','CentOS 7.4','CentOS 7.6'],
        'SUSE':['SUSE Linux Enterprise Server 12 SP2','SUSE Linux Enterprise Server 12 SP3','SUSE Linux Enterprise Server 12 SP5'],
        'Kylin':['Kylin Linux Advanced Server V10 (Tercel)'],
        #'Kylin':['Kylin 4.0.2,NeoKylin Linux Server 7.0 (loongson)',
        #        'NeoKylin Linux Advanced Server V7Update4 (Titanium)',
        #        'NeoKylin Linux Advanced Server V7Update6 (Chromium)'],
        #'Deepin':['Deepin 15'],
        #'NFS':['NFS Server 3.1 (RTM4-U1)'],
        #'UOS': ['Uniontech OS Server 20 Enterprise']
         }

class CheckOsVersion():
    def checkType(self):
        env,app = get_args()
        cf = configdict.get(app,{}).get("os",{})
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        elif ostype == 'Ubuntu':
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            output3 = output3[:12]
            ubuntu = cf["Ubuntu"]
            if(output3 in ubuntu):
                info=" OS  support  type :  "+output3+"支持。"
                #logging.info(" OS  support  type :  "+output3+"支持。")
                return info, 1,""
            else:
                info=" OS  support  type :  "+output3+"不支持 !"
                #logging.warning(" OS  support  type :  "+output3+"不支持 !")
                return info, 0,"该系统暂不支持,请更换Ubuntu 16.04系统后重试"
        elif ostype == 'CentOS':
            output2 = os.popen('cat /etc/redhat-release')
            output2 = output2.read()
            output2 = output2[21:24]
            if "centos {}".format(output2) in [c.lower() for c in cf['centos']]:
                info=" OS  support  type :  CentOS "+output2+"支持。"
                #logging.info(" OS  support  type :  "+output2+"支持。")
                return info, 1,""
            else:
                info=" OS  support  type :  CentOS "+output2+"不支持 !"
                #logging.warning(" OS  support  type :  "+output2+"不支持 !")
                return info, 0,"该系统暂不支持,请更换CentOS7.3/CentOS7.4/CentOS7.6系统后重试"
        elif ostype == 'Red Hat':
            output2 = os.popen('cat /etc/redhat-release')
            output2 = output2.read()
            output2 = output2[:43]
            redhat = cf["Red Hat"]
            if(output2 in redhat):
                info=" OS  support  type :  "+output2+"支持。"
                #logging.info(" OS  support  type :  "+output2+"支持。")
                return info, 1,""
            else:
                info=" OS  support  type :  "+output2+"不支持 !"
                #logging.warning(" OS  support  type :  "+output2+"不支持 !")
                return info, 0,"该系统暂不支持,请更换Red Hat Enterprise Linux Server release 7.4系统后重试"
        elif ostype == 'SUSE':
            output2 = os.popen('cat /etc/os-release | grep PRETTY_NAME')
            output2 = output2.read()
            output2 = output2[13:-2]
            suse = cf["SUSE"]
            if(output2 in suse):
                info=" OS  support  type :  "+output2+"支持。"
                #logging.info(" OS  support  type :  "+output2+"支持。")
                return info, 1,""
            else:
                info=" OS  support  type :  "+output2+"不支持 !"
                #logging.warning(" OS  support  type :  "+output2+"不支持 !")
                return info, 0,"该系统暂不支持,请更换SUSE Linux Enterprise Server 12 SP2/SP3系统后重试"
        elif ostype in ['Kylin','Kylin-V10']:
            output2 = os.popen('cat /etc/os-release | grep PRETTY_NAME')
            output2 = output2.read()
            output2 = output2[13:-2]
            kylin = cf["Kylin"]
            if(output2 in kylin):
                info=" OS  support  type :  "+output2+"支持。"
                #logging.info(" OS  support  type :  "+output2+"支持。")
                return info, 1,""
            else:
                info=" OS  support  type :  "+output2+"不支持 !"
                #logging.warning(" OS  support  type :  "+output2+"不支持 !")
                return info, 0,"该系统暂不支持,请更换Kylin Linux Advanced Server V10 (Tercel)系统后重试"
        elif ostype == 'NFS':
            output2 = os.popen('cat /etc/os-release | grep PRETTY_NAME')
            output2 = output2.read()
            output2 = output2[13:-2]
            nfs = cf["NFS"]
            if(output2 in nfs):
                info=" OS  support  type :  "+output2+"支持。"
                #logging.info(" OS  support  type :  "+output2+"支持。")
                return info, 1,""
            else:
                info=" OS  support  type :  "+output2+"不支持 !"
                #logging.warning(" OS  support  type :  "+output2+"不支持 !")
                return info, 0,"该系统暂不支持,请更换系统"
        elif ostype == 'Deepin':
            output2 = os.popen('cat /etc/os-release | grep PRETTY_NAME')
            output2 = output2.read()
            output2 = output2[13:-2]
            Deepin = cf["Deepin"]
            if(output2 in Deepin):
                info=" OS  support  type :  "+output2+"支持。"
                #logging.info(" OS  support  type :  "+output2+"支持。")
                return info, 1,""
            else:
                info=" OS  support  type :  "+output2+"不支持 !"
                #logging.warning(" OS  support  type :  "+output2+"不支持 !")
                return info, 0, "该系统暂不支持,请更换系统"
        elif ostype == 'UOS':
            output2 = os.popen('cat /etc/os-release | grep PRETTY_NAME').read()
            os_version = output2.strip().split('=')[1].strip('"')
            UOS = cf["UOS"]
            if os_version in UOS:
                info = " OS  support  type :  " + os_version + "支持。"
                #logging.info(" OS  support  type :  " + os_version + "支持。")
                return info, 1, ""
            else:
                info=" OS  support  type :  "+os_version+"不支持 !"
                #logging.warning(" OS  support  type :  "+os_version+"不支持 !")
                return info, 0, "该系统暂不支持,请更换系统"
        elif ostype == 'Darwin':
            info=" OS  support  type :  Darwin不支持 !"
            #logging.warning(" OS  support  type :  Darwin不支持  !")
            return info,0,"该系统暂不支持,请更换系统"
        else:
            info=" OS  support  type :  {}不支持 !".format(ostype)
            #logging.warning(" OS  support  type :  other不支持 !")
            return info,0,"该系统暂不支持,请更换系统"

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            elif 'Uniontech OS' in (output1 + output2 + output3):
                return 'UOS'
            else:
                return "other"

    def main(self):
        """
        :type messageTable: object
        """
        return self.checkType()

if __name__ == '__main__':
    checkOsVersion = CheckOsVersion()
    info,status,suggest = checkOsVersion.main()
    print(json.dumps({'info': info, 'name':'检测操作系统版本','status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


