# -*- coding: utf-8 -*-
import json, os, sys, re,datetime,subprocess
import getpass
#reload(sys)
#sys.setdefaultencoding('utf-8')

class CheckSSH():
    
    def main(self):
        try:
            res = os.popen("sudo cat /etc/ssh/sshd_config |grep 'PubkeyAuthentication'").read().strip('\n').strip(' ')
            if 'permission denied' in res.lower():
                return 'ssh配置检查失败',0,'请检查当前用户是否有权限读取/etc/ssh/sshd_config配置文件'
            if res.startswith('#'):
                return 'ssh设置正常',1,''
            else:
                if 'yes' in res:
                    return  'ssh设置正常',1,''
                else:
                    return 'SSH参数设置不正确',0,'请将/etc/ssh/sshd_config配置文件中PubkeyAuthentication 参数改成yes,或者注释掉该配置,再重启ssh服务'
            
        except:
            info = '当前用户没有sudo权限'
            return info,0,'请先设置当前用户sudo权限'


if __name__ == '__main__':
    info,status,suggest = CheckSSH().main()
    print(json.dumps({'info':info,'name':'检查SSH参数配置','status':status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))