# -*- coding: utf-8 -*-
import json
import os
import getpass
import pwd
import datetime
import sys
#sys.reload(sys)
#sys.setdefaultencoding('utf-8')

class CheckUser():
    
    def Login_user(self):      
        login_user = getpass.getuser()
        return login_user

    def Kubewps_user(self):
        dir_user = os.getcwd()
        dir_stat = os.lstat(dir_user)
        dir_uid = dir_stat.st_uid
        dir_pw = pwd.getpwuid(dir_uid)
        kubewps_user = dir_pw.pw_name
        return kubewps_user
        
    def Config_user(self):
        try:
            user = sys.argv[4]
        except:
            user = 'wps'
        return user.strip()

    def checkUser(self):
        Login_user = self.Login_user()
        Kubewps_user = self.Kubewps_user()
        Config_user = self.Config_user()
        if Kubewps_user == Config_user:
            info="目录所属用户:(%s),kubewps.conf配置用户:(%s)  一致。"%(Kubewps_user,Config_user)
            return info,1,""
        else:
            info="目录所属用户:(%s),kubewps.conf配置用户:(%s)  不一致，请检测!"%(Kubewps_user,Config_user)
            return info,0,"请切换到kubewps所属用户执行"

    def main(self):
        return self.checkUser()

if __name__ == '__main__':
    checkUser=CheckUser()
    info,status,suggest=checkUser.main()
    print(json.dumps({'info':info,'name':'用户一致性检测','status':status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))
