# -*- coding: utf-8 -*-
import json, os, sys, re,datetime
#reload(sys)
#sys.setdefaultencoding('utf-8')
def is_en_char(word):
    for o in word:
        if ord(o) > 128:
            return False
    return True
class CheckChinese():
    def getdirlist(self):
        c_dir = os.getcwd().split('/')
        c_dir_list = filter(None,c_dir)
        return c_dir_list
    
    def checkChinese(self):
        dir_list = self.getdirlist()
        info = "K8S部署包所在的路径中不含有中文或空格。"
        status=1
        suggest = ''
        for dir in dir_list:
            if re.search(r"\s",dir):
                info = "K8S部署包所在的目录中含有空格!"
                status = 0
                suggest = "去掉K8S部署包所在目录中的空格"
                break
            if not is_en_char(dir):
                info = "K8S部署包所在的目录中含有中文!"
                status = 0
                suggest = "请去掉目录中的中文"
                break
        return info,status,suggest

    def main(self):
        return self.checkChinese()

if __name__ == '__main__':
    checkChinese = CheckChinese()
    info,status,suggest = checkChinese.main()
    print(json.dumps({'info':info,'name':'目录是否含有中文或空格检测','status':status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))