# -*- coding: utf-8 -*-
import logging
import platform,os
import sys
defaultencoding = 'utf-8'
##if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)
cfinfo ={'dependent':'/usr/bin/ssh-copy-id'}
import json
class CheckDependent():
    def checkDependent(self):
        cf = cfinfo
        # 检查系统依赖组建
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        osdependent=cf['dependent']
        osdependent=osdependent.split(',')
        warningOsDepen=''
        for depen in osdependent:
            output1=os.popen("ls -l " + depen + "| wc -l")
            output1=output1.read()
            try:
                output1=int(output1)
            except:
                output1 = 0
            if output1 != 1:
                if warningOsDepen == '':
                    warningOsDepen=depen
                else:
                    warningOsDepen=warningOsDepen + ',' + depen
        if warningOsDepen == '':
            info = " 这个系统依赖模块都已经安装。"
            #.info(" 这个系统依赖模块都已经安装。")
            return info,1,""
        else:
            info="这个系统还有："+warningOsDepen+" 未安装!"
            #logging.warning("这个系统还有："+warningOsDepen+" 未安装 !")
            return info,0,"请先安装所需依赖包"

    def main(self):
        """
        :type messageTable: object
        """
        return self.checkDependent()

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

if __name__ == '__main__':
    checkDependent = CheckDependent()
    info,status,suggest = checkDependent.main()
    print(json.dumps({'info': info, 'name':'检测依赖组件','status': status,"suggest":suggest}))

