# -*- coding: utf-8 -*-
import platform,os
import #logging,json
import sys
import datetime
defaultencoding = 'utf-8'
#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)


class CheckDisk():

    def checkfs(self,fstype):
        checkStatus=''
        result=os.popen("df -Th "+"/"+" | grep /dev/ | grep -v tmpfs  |awk '{print $2}'").read().replace("\n",'')
        if result:
            if result==fstype:
                return checkStatus
            elif result=="nfs" or result=="NFS":
                checkStatus="挂载不正常，不能使用nas挂载"
                return checkStatus
            else:
                checkStatus='挂载硬盘格式错误，请给{0}目录挂载{1}格式的硬盘'.format("/",fstype)
                return checkStatus

    cfinfo = {"use": 0.8, "size": 19922944, 'RootPath': '/'}

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def checkDisk(self):
        cf = self.cfinfo
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,"windows不支持"
        checkStatus = ''
        #硬盘使用率
        disk_str=""
        disk_used = os.popen("df -h / | grep /dev/ | grep -v tmpfs | awk '{print $1,$2,$5}' | sort -n | uniq").read().strip().split("\n")
        for used in disk_used:
            used=float(used.split(" ")[2].split("%")[0])/100
            if used>cf["use"]:
                if disk_str=='':
                    if disk_str == '':
                        disk_str = '|'.join(disk_str)
                    else:
                        disk_str = disk_str + ',' + '|'.join(disk_str)
                if disk_str != '':
                    checkStatus = checkStatus+ "硬盘使用率不正常 " + disk_str
        # 全部硬盘分区大小
        warningDev = ''
        output2 = os.popen("df -h / | grep /dev/ | grep -v tmpfs | awk '{print $1,$2,$5}' | sort -n | uniq")  # 所有盘分区大小
        output2 = output2.read().strip().split("\n")
        for devItem in output2:
            devItem = devItem.split(" ")
            userd = float(devItem[2].split("%")[0]) / 100
            if userd > cf["use"]:
                if warningDev == '':
                    warningDev = '|'.join(devItem)
                else:
                    warningDev = warningDev + ',' + '|'.join(devItem)
        if warningDev != '':
            checkStatus = checkStatus + "硬盘使用率不正常 " + warningDev
        # 系统盘分区大小
        systemData=os.popen("df | grep /dev/ | grep -v tmpfs  | grep -E '/$' | awk '{print $2}'")
        size=int(systemData.read().strip())
        if size < cf["size"]:
            print_size = os.popen("df -h / |grep /dev | awk '{print $2}'").read().strip()
            checkStatus=checkStatus + "系统盘大小不正常 "+print_size

        # 数据盘挂载格式
        if ostype=="Ubuntu":
            checkStatus=checkStatus+self.checkfs("ext4")
        if ostype=="Red Hat":
            checkStatus=checkStatus+self.checkfs("xfs")
        if ostype=="CentOS":
            checkStatus=checkStatus+self.checkfs('xfs')
        if ostype=="SUSE":
            checkStatus=checkStatus+self.checkfs('btrfs')
        if ostype=="Kylin":
            checkStatus=checkStatus+self.checkfs("ext4")
        if ostype=="other":
            pass

        if checkStatus == '':
            info="硬盘检查正常。"
            #logging.info("硬盘检查正常。")
            return info,1,""
        else:
            info="硬盘检查不正常:" + checkStatus + "!"
            #logging.warning("硬盘检查不正常:" + checkStatus + "!")
            return info,0,"检查磁盘分区格式/可用大小/inode数量等关键信息"



    def main(self):
        return self.checkDisk()

if __name__ == '__main__':
    checkDisk = CheckDisk()
    info,status,suggest = checkDisk.main()
    print(json.dumps({'info': info,'name':'检测硬盘','status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))