# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
defaultencoding = 'utf-8'
#if sys.getdefaultencoding() != defaultencoding:
    ##reload(sys)
    #sys.setdefaultencoding(defaultencoding)


cfinfo ={"netSub":["10.186.","10.187.","172.25","172.27"]}

class CheckNetSub():
    def checkNetSub(self):
        cf = cfinfo
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        sysctlItems=cf["netSub"]
        #sysctlItems=sysctlItems.split(',')
        warningSysctl = []
        output1=os.popen("ip a | grep 'inet *' |grep -Ev 'docker|cni|flannel|bird|::'|awk '{print $2}'").read().strip().split('\n')
        for sysctlItem in sysctlItems:
            for out in output1:
                if out.startswith(sysctlItem):
                    warningSysctl.append(sysctlItem)
        if not warningSysctl:
            info = " 网段没有被占用,当前所用网段 {}。".format(','.join(output1))
            #logging.info(" 网段没有被占用没有被占用。")
            return info,1,""
        else:
            info = " 网段 : " + ','.join(warningSysctl) + " 被占用!"
            #logging.warning(" 网段 : " + warningSysctl + " 被占用!")
            return info,0,"网段被占用,请更换主机网段,使用ip a | grep 'inet *' |awk '{print $2}' | grep -v :: 命令查看"

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def main(self):
        return self.checkNetSub()

if __name__ == '__main__':
    checkNetSub = CheckNetSub()
    info,status,suggest = checkNetSub.main()
    print(json.dumps({'info': info,'name':'检测主机网段', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


