# -*- coding: utf-8 -*-
import logging,json
import os,platform
import sys
import datetime
defaultencoding = 'utf-8'
#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)

cfinfo ={}

class CheckSelinux():
    def checkSelinux(self):
        cf = cfinfo
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        # 检查selinux
        output1=os.popen("whereis getenforce")
        output1=output1.read().strip().split(":")[1]
        if output1 != '':
            output1=os.popen("sudo getenforce")
            output1=output1.read().strip('\n').lower()
            if output1 in ['disabled','permissive']:
                info="Selinux已经关闭。"
                #logging.info("Selinux已经关闭。")
                return info, 1,""
            else:
                info="Selinux未关闭 !"
                #logging.warning("Selinux未关闭  !")
                return info, 0,"请关闭selinux.1 临时关闭: setenforce 0.\n 2永久关闭: 修改/etc/selinux/config 文件\n,将SELINUX=enforcing改为SELINUX=disabled,重启机器"
        else:
            info="Selinux已经关闭。"
            #logging.info("Selinux已经关闭。")
            return info, 1,""

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def main(self):
        """
        :type messageTable: object
        """
        return self.checkSelinux()

if __name__ == '__main__':
    checkSelinux = CheckSelinux()
    info,status,suggest = checkSelinux.main()
    print(json.dumps({'info': info,'name':'检测selinux状态', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))


