# -*- coding: utf-8 -*-
import json
from datetime import datetime
import time
import os
import json
import sys

def get_deploy_time():
    try:
        return int(sys.argv[5])
    except:
        return 0
class CheckTime():

    def checkTime(self):
        deploy_time = get_deploy_time()
        local_time = int(time.time())
        #print (deploy_time,local_time)
        timezone_info = os.popen("date -R").read().strip("\n")
        zone_check = True
        if '+08' not in timezone_info:
            zone_check = False
        if deploy_time > local_time:
            delta = deploy_time - local_time
        else:
            delta = local_time - deploy_time
        if delta < 10:
            info="日期检查正常,系统当前时间为"+datetime.now().strftime("%Y-%m-%d %H:%M:%S")
            suggest = ""
            if not zone_check:
                suggest = "警告: 当前时区不是+08,请检查时区设置"
            return info,1,suggest
        else:
            info="日期检查不正常,与部署机时间间隔超过5秒,系统当前时间为"+datetime.now().strftime("%Y-%m-%d %H:%M:%S")+"请修改!"
        return info,0,"请同步当前系统时间"


    def main(self):
        return self.checkTime()

if __name__ == '__main__':
    checkTime=CheckTime()
    info,status,suggest=checkTime.main()
    print(json.dumps({'info':info,'name':'检测时间','status':status,"suggest":suggest,"check_date":datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))