# -*- coding: utf-8 -*-
import os,platform
import logging,json
import sys
import datetime
import getpass
defaultencoding = 'utf-8'
#if sys.getdefaultencoding() != defaultencoding:
    #reload(sys)
    #sys.setdefaultencoding(defaultencoding)

cfinfo ={}

def get_user():
    try:
        user = sys.argv[4]
    except:
        user = getpass.getuser()
    return user.strip()
class CheckUmask():

    def checkUmask(self):
        cf = cfinfo
        ostype = self.osType()
        if ostype == 'Windows':
            info=" windows不支持!"
            #logging.warning(" windows不支持!")
            return info,0,""
        Config_user = get_user()
        output1 = os.popen("umask")
        output1 = output1.read().strip()
        if output1 in ['0022','0002']:
            info = "{}用户umask正常.".format(Config_user)
            #logging.info(" %s 的umask正常。"%Config_user)
            return info,1,""
        else:
            info = "{}用户umask不符合要求,当前umask值为{},请配置成0022或者0002!".format(Config_user,output1)
            #logging.warning(" %s 的umask不是0022 !"%Config_user)
            return info,0,"请设置{}用户umask为0022或者0002, umask 0022".format(Config_user)

    def osType(self):
        osType = platform.system()
        if osType == 'Windows' or osType == 'Darwin':
            return osType
        elif osType == 'Linux':
            output1 = os.popen('lsb_release -a')
            output1 = output1.read()
            output2 = os.popen('cat /etc/os-release')
            output2 = output2.read()
            output3 = os.popen('cat /etc/issue')
            output3 = output3.read()
            if (('Ubuntu' in output1) or ('Ubuntu' in output2) or ('Ubuntu' in output3)):
                return "Ubuntu"
            elif (('CentOS' in output1) or ('CentOS' in output2) or ('CentOS' in output3)):
                return "CentOS"
            elif (('Red Hat' in output1) or ('Red Hat' in output2) or ('Red Hat' in output3)):
                return "Red Hat"
            elif (('SUSE' in output1) or ('SUSE' in output2) or ('SUSE' in output3)):
                return "SUSE"
            elif (('Kylin' in output1) or ('Kylin' in output2) or ('Kylin' in output3)):
                if (('NeoKylin' in output1) or ('NeoKylin' in output2) or ('NeoKylin' in output3)):
                    return "neokylin"
                elif (('V10' in output1) or ('V10' in output2) or ('V10' in output3)):
                    return "Kylin-V10"
                else:
                    return "Kylin"
            elif (('NFS' in output1) or ('NFS' in output2) or ('NFS' in output3)):
                return "NFS"
            elif (('Deepin' in output1) or ('Deepin' in output2) or ('Deepin' in output3)):
                return "Deepin"
            else:
                return "other"

    def main(self):
        return self.checkUmask()

if __name__ == '__main__':
    checkUmask = CheckUmask()
    info,status,suggest = checkUmask.main()
    print(json.dumps({'info': info,'name':'检测umask状态', 'status': status,"suggest":suggest,"check_date":datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")}))